#include "params.h"

#include <stddef.h>
#include <openssl/sha.h>

#include <string.h>

int varlen_hash(unsigned char *out,const unsigned char *in,unsigned long long inlen)
{
  SHA256(in,inlen,out);
  return 0;
}

int msg_hash(unsigned char *out,const unsigned char *in,unsigned long long inlen)
{
  SHA512(in,inlen,out);
  return 0;
}


int hash_n_n(unsigned char *out,const unsigned char *in)
{
#if HASH_BYTES != 32
#error "Current code only supports 32-byte hashes"
#endif

  SHA256(in, 64, out);
  
  return 0;
}

int hash_n_n_mask(unsigned char *out,const unsigned char *in, const unsigned char *mask, unsigned char ftn_key[HASH_BYTES])
{
  int i;
  unsigned char buf[64];

  memcpy(buf, ftn_key, HASH_BYTES);

  for(i=HASH_BYTES;i<64;i++)
    buf[i] = in[i] ^ mask[i];

  return hash_n_n(out, buf);
}

